Index: serefpolicy-contrib-20140730/networkmanager.if
===================================================================
--- serefpolicy-contrib-20140730.orig/networkmanager.if
+++ serefpolicy-contrib-20140730/networkmanager.if
@@ -2,7 +2,7 @@
 
 ########################################
 ## <summary>
-##	Read and write networkmanager udp sockets.
+##	Read and write NetworkManager UDP sockets.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -10,6 +10,7 @@
 ##	</summary>
 ## </param>
 #
+# cjp: added for named.
 interface(`networkmanager_rw_udp_sockets',`
 	gen_require(`
 		type NetworkManager_t;
@@ -20,7 +21,7 @@ interface(`networkmanager_rw_udp_sockets
 
 ########################################
 ## <summary>
-##	Read and write networkmanager packet sockets.
+##	Read and write NetworkManager packet sockets.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -28,6 +29,7 @@ interface(`networkmanager_rw_udp_sockets
 ##	</summary>
 ## </param>
 #
+# cjp: added for named.
 interface(`networkmanager_rw_packet_sockets',`
 	gen_require(`
 		type NetworkManager_t;
@@ -38,12 +40,12 @@ interface(`networkmanager_rw_packet_sock
 
 #######################################
 ## <summary>
-## Relabel networkmanager tun socket.
+## Allow caller to relabel tun_socket
 ## </summary>
 ## <param name="domain">
-## <summary>
-## Domain allowed access.
-## </summary>
+##	<summary>
+##	Domain allowed access.
+##	</summary>
 ## </param>
 #
 interface(`networkmanager_attach_tun_iface',`
@@ -57,7 +59,7 @@ interface(`networkmanager_attach_tun_ifa
 
 ########################################
 ## <summary>
-##	Read and write networkmanager netlink
+##	Read and write NetworkManager netlink
 ##	routing sockets.
 ## </summary>
 ## <param name="domain">
@@ -66,6 +68,7 @@ interface(`networkmanager_attach_tun_ifa
 ##	</summary>
 ## </param>
 #
+# cjp: added for named.
 interface(`networkmanager_rw_routing_sockets',`
 	gen_require(`
 		type NetworkManager_t;
@@ -76,7 +79,7 @@ interface(`networkmanager_rw_routing_soc
 
 ########################################
 ## <summary>
-##	Execute networkmanager with a domain transition.
+##	Execute NetworkManager with a domain transition.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -93,10 +96,27 @@ interface(`networkmanager_domtrans',`
 	domtrans_pattern($1, NetworkManager_exec_t, NetworkManager_t)
 ')
 
+#######################################
+## <summary>
+##      Execute NetworkManager scripts with an automatic domain transition to initrc.
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed to transition.
+##      </summary>
+## </param>
+#
+interface(`networkmanager_initrc_domtrans',`
+        gen_require(`
+                type NetworkManager_initrc_exec_t;
+        ')
+
+        init_labeled_script_domtrans($1, NetworkManager_initrc_exec_t)
+')
+
 ########################################
 ## <summary>
-##	Execute networkmanager scripts with
-##	an automatic domain transition to initrc.
+##	Execute NetworkManager server in the NetworkManager domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -104,18 +124,23 @@ interface(`networkmanager_domtrans',`
 ##	</summary>
 ## </param>
 #
-interface(`networkmanager_initrc_domtrans',`
+interface(`networkmanager_systemctl',`
 	gen_require(`
-		type NetworkManager_initrc_exec_t;
+		type NetworkManager_unit_file_t;
+		type NetworkManager_t;
 	')
 
-	init_labeled_script_domtrans($1, NetworkManager_initrc_exec_t)
+	systemd_exec_systemctl($1)
+	allow $1 NetworkManager_unit_file_t:file read_file_perms;
+	allow $1 NetworkManager_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, NetworkManager_t)
 ')
 
 ########################################
 ## <summary>
 ##	Send and receive messages from
-##	networkmanager over dbus.
+##	NetworkManager over dbus.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -155,7 +180,29 @@ interface(`networkmanager_read_state',`
 
 ########################################
 ## <summary>
-##	Send generic signals to networkmanager.
+##	Do not audit attempts to send and
+##	receive messages from NetworkManager
+##	over dbus.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain to not audit.
+##	</summary>
+## </param>
+#
+interface(`networkmanager_dontaudit_dbus_chat',`
+	gen_require(`
+		type NetworkManager_t;
+		class dbus send_msg;
+	')
+
+	dontaudit $1 NetworkManager_t:dbus send_msg;
+	dontaudit NetworkManager_t $1:dbus send_msg;
+')
+
+########################################
+## <summary>
+##	Send a generic signal to NetworkManager
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -211,9 +258,28 @@ interface(`networkmanager_read_lib_files
 	read_files_pattern($1, NetworkManager_var_lib_t, NetworkManager_var_lib_t)
 ')
 
+#######################################
+## <summary>
+##  Read NetworkManager conf files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`networkmanager_read_conf',`
+    gen_require(`
+        type NetworkManager_etc_t;
+    ')
+
+	allow $1 NetworkManager_etc_t:dir list_dir_perms;
+	read_files_pattern($1,NetworkManager_etc_t,NetworkManager_etc_t)
+')
+
 ########################################
 ## <summary>
-##	Append networkmanager log files.
+##	Read NetworkManager PID files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -221,19 +287,18 @@ interface(`networkmanager_read_lib_files
 ##	</summary>
 ## </param>
 #
-interface(`networkmanager_append_log_files',`
+interface(`networkmanager_read_pid_files',`
 	gen_require(`
-		type NetworkManager_log_t;
+		type NetworkManager_var_run_t;
 	')
 
-	logging_search_logs($1)
-	allow $1 NetworkManager_log_t:dir list_dir_perms;
-	append_files_pattern($1, NetworkManager_log_t, NetworkManager_log_t)
+	files_search_pids($1)
+	read_files_pattern($1, NetworkManager_var_run_t, NetworkManager_var_run_t)
 ')
 
 ########################################
 ## <summary>
-##	Read networkmanager pid files.
+##	Manage NetworkManager PID files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -241,13 +306,13 @@ interface(`networkmanager_append_log_fil
 ##	</summary>
 ## </param>
 #
-interface(`networkmanager_read_pid_files',`
+interface(`networkmanager_manage_pid_files',`
 	gen_require(`
 		type NetworkManager_var_run_t;
 	')
 
 	files_search_pids($1)
-	allow $1 NetworkManager_var_run_t:file read_file_perms;
+	manage_files_pattern($1, NetworkManager_var_run_t, NetworkManager_var_run_t)
 ')
 
 ####################################
@@ -272,14 +337,33 @@ interface(`networkmanager_stream_connect
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an networkmanager environment.
+##	Delete NetworkManager PID files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
+#
+interface(`networkmanager_delete_pid_files',`
+	gen_require(`
+		type NetworkManager_var_run_t;
+	')
+
+	files_search_pids($1)
+    delete_files_pattern($1, NetworkManager_var_run_t, NetworkManager_var_run_t)
+')
+
+########################################
+## <summary>
+##	Execute NetworkManager in the NetworkManager domain, and
+##	allow the specified role the NetworkManager domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
 ## <param name="role">
 ##	<summary>
 ##	Role allowed access.
@@ -287,33 +371,132 @@ interface(`networkmanager_stream_connect
 ## </param>
 ## <rolecap/>
 #
-interface(`networkmanager_admin',`
+interface(`networkmanager_run',`
 	gen_require(`
-		type NetworkManager_t, NetworkManager_initrc_exec_t, NetworkManager_etc_t;
-		type NetworkManager_etc_rw_t, NetworkManager_log_t, NetworkManager_tmp_t;
-		type NetworkManager_var_lib_t, NetworkManager_var_run_t, wpa_cli_t;
+		type NetworkManager_t, NetworkManager_exec_t;
 	')
 
-	allow $1 { wpa_cli_t NetworkManager_t }:process { ptrace signal_perms };
-	ps_process_pattern($1, { wpa_cli_t NetworkManager_t })
-
-	init_labeled_script_domtrans($1, NetworkManager_initrc_exec_t)
-	domain_system_change_exemption($1)
-	role_transition $2 NetworkManager_initrc_exec_t system_r;
-	allow $2 system_r;
+	networkmanager_domtrans($1)
+	role $2 types NetworkManager_t;
+')
 
-	logging_search_etc($1)
-	admin_pattern($1, { NetworkManager_etc_t NetworkManager_etc_rw_t })
+########################################
+## <summary>
+##	Allow the specified domain to append
+##	to Network Manager log files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`networkmanager_append_log',`
+	gen_require(`
+		type NetworkManager_log_t;
+	')
 
 	logging_search_logs($1)
-	admin_pattern($1, NetworkManager_log_t)
+	allow $1 NetworkManager_log_t:dir list_dir_perms;
+	append_files_pattern($1, NetworkManager_log_t, NetworkManager_log_t)
+')
 
-	files_search_var_lib($1)
-	admin_pattern($1, NetworkManager_var_lib_t)
+#######################################
+## <summary>
+##  Allow the specified domain to manage
+##  to Network Manager lib files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`networkmanager_manage_lib',`
+    gen_require(`
+        type NetworkManager_var_lib_t;
+    ')
+
+    manage_files_pattern($1, NetworkManager_var_lib_t, NetworkManager_var_lib_t)
+')
+
+#######################################
+## <summary>
+##      Read the process state (/proc/pid) of NetworkManager.
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`NetworkManager_read_state',`
+        gen_require(`
+            type NetworkManager_t;
+    ')
+
+    allow $1 NetworkManager_t:dir search_dir_perms;
+    allow $1 NetworkManager_t:file read_file_perms;
+    allow $1 NetworkManager_t:lnk_file read_lnk_file_perms;
+')
+
+#######################################
+## <summary>
+##	Send to NetworkManager with a unix dgram socket.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`networkmanager_dgram_send',`
+	gen_require(`
+		type NetworkManager_t, NetworkManager_var_run_t;
+	')
 
 	files_search_pids($1)
-	admin_pattern($1, NetworkManager_var_run_t)
+	dgram_send_pattern($1, NetworkManager_var_run_t, NetworkManager_var_run_t, NetworkManager_t)
+')
+
+########################################
+## <summary>
+##	Transition to networkmanager named content
+## </summary>
+## <param name="domain">
+##	<summary>
+##      Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`networkmanager_filetrans_named_content',`
+	gen_require(`
+		type NetworkManager_var_run_t;
+		type NetworkManager_var_lib_t;
+	')
 
-	files_search_tmp($1)
-	admin_pattern($1, NetworkManager_tmp_t)
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient.-eth0.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient.-eth1.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient.-eth2.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient.-eth3.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient.-eth4.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient.-eth5.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient.-eth6.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient.-eth7.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient.-eth8.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient.-eth9.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient-em0.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient-em1.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient-em2.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient-em3.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient-em4.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient-em5.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient-em6.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient-em7.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "nm-dhclient-em8.conf")
+	files_pid_filetrans($1, NetworkManager_var_run_t, file, "wicd.pid")
+	files_etc_filetrans($1, NetworkManager_var_lib_t, file, "manager-settings.conf")
+	files_etc_filetrans($1, NetworkManager_var_lib_t, file, "wireless-settings.conf")
+	files_etc_filetrans($1, NetworkManager_var_lib_t, file, "wired-settings.conf")
+	logging_log_filetrans($1, NetworkManager_var_lib_t, file, "wpa_supplicant.log")
 ')
Index: serefpolicy-contrib-20140730/networkmanager.te
===================================================================
--- serefpolicy-contrib-20140730.orig/networkmanager.te
+++ serefpolicy-contrib-20140730/networkmanager.te
@@ -1,4 +1,4 @@
-policy_module(networkmanager, 1.16.0)
+policy_module(networkmanager, 1.15.2)
 
 ########################################
 #
@@ -9,15 +9,18 @@ type NetworkManager_t;
 type NetworkManager_exec_t;
 init_daemon_domain(NetworkManager_t, NetworkManager_exec_t)
 
+type NetworkManager_initrc_exec_t;
+init_script_file(NetworkManager_initrc_exec_t)
+
+type NetworkManager_unit_file_t;
+systemd_unit_file(NetworkManager_unit_file_t)
+
 type NetworkManager_etc_t;
 files_config_file(NetworkManager_etc_t)
 
 type NetworkManager_etc_rw_t;
 files_config_file(NetworkManager_etc_rw_t)
 
-type NetworkManager_initrc_exec_t;
-init_script_file(NetworkManager_initrc_exec_t)
-
 type NetworkManager_log_t;
 logging_log_file(NetworkManager_log_t)
 
@@ -39,25 +42,53 @@ init_system_domain(wpa_cli_t, wpa_cli_ex
 # Local policy
 #
 
-allow NetworkManager_t self:capability { fowner chown fsetid kill setgid setuid sys_nice dac_override net_admin net_raw ipc_lock };
-dontaudit NetworkManager_t self:capability { sys_tty_config sys_module sys_ptrace };
-allow NetworkManager_t self:process { ptrace getcap setcap setpgid getsched setsched signal_perms };
+# networkmanager will ptrace itself if gdb is installed
+# and it receives a unexpected signal (rh bug #204161)
+allow NetworkManager_t self:capability { fowner chown fsetid kill setgid setuid sys_admin sys_nice dac_override net_admin net_raw net_bind_service ipc_lock sys_chroot };
+dontaudit NetworkManager_t self:capability sys_tty_config;
+
+ifdef(`hide_broken_symptoms',`
+	# caused by some bogus kernel code
+	dontaudit NetworkManager_t self:capability sys_module;
+')
+
+allow NetworkManager_t self:process { getcap setcap setpgid getsched setsched signal_perms };
+
+allow NetworkManager_t self:process setfscreate;
+selinux_validate_context(NetworkManager_t)
+
+tunable_policy(`deny_ptrace',`',`
+	allow NetworkManager_t self:capability sys_ptrace;
+	allow NetworkManager_t self:process ptrace;
+')
+
 allow NetworkManager_t self:fifo_file rw_fifo_file_perms;
-allow NetworkManager_t self:unix_dgram_socket sendto;
-allow NetworkManager_t self:unix_stream_socket { accept listen };
+allow NetworkManager_t self:unix_dgram_socket { sendto create_socket_perms };
+allow NetworkManager_t self:unix_stream_socket{ create_stream_socket_perms connectto };
 allow NetworkManager_t self:netlink_route_socket create_netlink_socket_perms;
+allow NetworkManager_t self:netlink_xfrm_socket create_netlink_socket_perms;
 allow NetworkManager_t self:netlink_socket create_socket_perms;
 allow NetworkManager_t self:netlink_kobject_uevent_socket create_socket_perms;
-allow NetworkManager_t self:tcp_socket { accept listen };
+allow NetworkManager_t self:tcp_socket create_stream_socket_perms;
 allow NetworkManager_t self:tun_socket { create_socket_perms relabelfrom relabelto };
+allow NetworkManager_t self:udp_socket create_socket_perms;
 allow NetworkManager_t self:packet_socket create_socket_perms;
+allow NetworkManager_t self:rawip_socket create_socket_perms;
 
 allow NetworkManager_t wpa_cli_t:unix_dgram_socket sendto;
 
-allow NetworkManager_t NetworkManager_etc_t:dir list_dir_perms;
-allow NetworkManager_t NetworkManager_etc_t:file read_file_perms;
-allow NetworkManager_t NetworkManager_etc_t:lnk_file read_lnk_file_perms;
+can_exec(NetworkManager_t, NetworkManager_exec_t)
+#wicd
+can_exec(NetworkManager_t, wpa_cli_exec_t)
+
+list_dirs_pattern(NetworkManager_t, NetworkManager_initrc_exec_t, NetworkManager_initrc_exec_t)
+read_files_pattern(NetworkManager_t, NetworkManager_initrc_exec_t, NetworkManager_initrc_exec_t)
+
+list_dirs_pattern(NetworkManager_t, NetworkManager_etc_t, NetworkManager_etc_t)
+read_files_pattern(NetworkManager_t, NetworkManager_etc_t, NetworkManager_etc_t)
+read_lnk_files_pattern(NetworkManager_t, NetworkManager_etc_t, NetworkManager_etc_t)
 
+read_lnk_files_pattern(NetworkManager_t, NetworkManager_etc_rw_t, NetworkManager_etc_rw_t)
 manage_dirs_pattern(NetworkManager_t, NetworkManager_etc_rw_t, NetworkManager_etc_rw_t)
 manage_files_pattern(NetworkManager_t, NetworkManager_etc_rw_t, NetworkManager_etc_rw_t)
 filetrans_pattern(NetworkManager_t, NetworkManager_etc_t, NetworkManager_etc_rw_t, { dir file })
@@ -68,6 +99,7 @@ create_files_pattern(NetworkManager_t, N
 setattr_files_pattern(NetworkManager_t, NetworkManager_log_t, NetworkManager_log_t)
 logging_log_filetrans(NetworkManager_t, NetworkManager_log_t, file)
 
+can_exec(NetworkManager_t, NetworkManager_tmp_t)
 manage_files_pattern(NetworkManager_t, NetworkManager_tmp_t, NetworkManager_tmp_t)
 manage_sock_files_pattern(NetworkManager_t, NetworkManager_tmp_t, NetworkManager_tmp_t)
 files_tmp_filetrans(NetworkManager_t, NetworkManager_tmp_t, { sock_file file })
@@ -81,17 +113,14 @@ manage_files_pattern(NetworkManager_t, N
 manage_sock_files_pattern(NetworkManager_t, NetworkManager_var_run_t, NetworkManager_var_run_t)
 files_pid_filetrans(NetworkManager_t, NetworkManager_var_run_t, { dir file sock_file })
 
-can_exec(NetworkManager_t, { NetworkManager_exec_t wpa_cli_exec_t NetworkManager_tmp_t })
-
-kernel_read_crypto_sysctls(NetworkManager_t)
 kernel_read_system_state(NetworkManager_t)
 kernel_read_network_state(NetworkManager_t)
 kernel_read_kernel_sysctls(NetworkManager_t)
 kernel_request_load_module(NetworkManager_t)
 kernel_read_debugfs(NetworkManager_t)
 kernel_rw_net_sysctls(NetworkManager_t)
+kernel_dontaudit_setsched(NetworkManager_t)
 
-corenet_all_recvfrom_unlabeled(NetworkManager_t)
 corenet_all_recvfrom_netlabel(NetworkManager_t)
 corenet_tcp_sendrecv_generic_if(NetworkManager_t)
 corenet_udp_sendrecv_generic_if(NetworkManager_t)
@@ -102,22 +131,15 @@ corenet_raw_sendrecv_generic_node(Networ
 corenet_tcp_sendrecv_all_ports(NetworkManager_t)
 corenet_udp_sendrecv_all_ports(NetworkManager_t)
 corenet_udp_bind_generic_node(NetworkManager_t)
-
-corenet_sendrecv_isakmp_server_packets(NetworkManager_t)
 corenet_udp_bind_isakmp_port(NetworkManager_t)
-
-corenet_sendrecv_dhcpc_server_packets(NetworkManager_t)
 corenet_udp_bind_dhcpc_port(NetworkManager_t)
-
-corenet_sendrecv_all_client_packets(NetworkManager_t)
 corenet_tcp_connect_all_ports(NetworkManager_t)
-
+corenet_sendrecv_isakmp_server_packets(NetworkManager_t)
+corenet_sendrecv_dhcpc_server_packets(NetworkManager_t)
+corenet_sendrecv_all_client_packets(NetworkManager_t)
 corenet_rw_tun_tap_dev(NetworkManager_t)
 corenet_getattr_ppp_dev(NetworkManager_t)
 
-corecmd_exec_shell(NetworkManager_t)
-corecmd_exec_bin(NetworkManager_t)
-
 dev_rw_sysfs(NetworkManager_t)
 dev_read_rand(NetworkManager_t)
 dev_read_urand(NetworkManager_t)
@@ -125,13 +147,6 @@ dev_dontaudit_getattr_generic_blk_files(
 dev_getattr_all_chr_files(NetworkManager_t)
 dev_rw_wireless(NetworkManager_t)
 
-domain_use_interactive_fds(NetworkManager_t)
-domain_read_all_domains_state(NetworkManager_t)
-
-files_read_etc_runtime_files(NetworkManager_t)
-files_read_usr_files(NetworkManager_t)
-files_read_usr_src_files(NetworkManager_t)
-
 fs_getattr_all_fs(NetworkManager_t)
 fs_search_auto_mountpoints(NetworkManager_t)
 fs_list_inotifyfs(NetworkManager_t)
@@ -140,18 +155,33 @@ mls_file_read_all_levels(NetworkManager_
 
 selinux_dontaudit_search_fs(NetworkManager_t)
 
+corecmd_exec_shell(NetworkManager_t)
+corecmd_exec_bin(NetworkManager_t)
+
+domain_use_interactive_fds(NetworkManager_t)
+domain_read_all_domains_state(NetworkManager_t)
+
+files_read_etc_runtime_files(NetworkManager_t)
+files_read_system_conf_files(NetworkManager_t)
+files_read_usr_src_files(NetworkManager_t)
+files_read_isid_type_files(NetworkManager_t)
+
 storage_getattr_fixed_disk_dev(NetworkManager_t)
 
 init_read_utmp(NetworkManager_t)
 init_dontaudit_write_utmp(NetworkManager_t)
 init_domtrans_script(NetworkManager_t)
+init_signull_script(NetworkManager_t)
+init_signal_script(NetworkManager_t)
+init_sigkill_script(NetworkManager_t)
 
 auth_use_nsswitch(NetworkManager_t)
 
+libs_exec_ldconfig(NetworkManager_t)
+
 logging_send_syslog_msg(NetworkManager_t)
 
 miscfiles_read_generic_certs(NetworkManager_t)
-miscfiles_read_localization(NetworkManager_t)
 
 seutil_read_config(NetworkManager_t)
 
@@ -166,21 +196,32 @@ sysnet_kill_dhcpc(NetworkManager_t)
 sysnet_read_dhcpc_state(NetworkManager_t)
 sysnet_delete_dhcpc_state(NetworkManager_t)
 sysnet_search_dhcp_state(NetworkManager_t)
+# in /etc created by NetworkManager will be labelled net_conf_t.
 sysnet_manage_config(NetworkManager_t)
 sysnet_etc_filetrans_config(NetworkManager_t)
 
-# certificates in user home directories (cert_home_t in ~/\.pki)
-userdom_read_user_home_content_files(NetworkManager_t)
-
-userdom_write_user_tmp_sockets(NetworkManager_t)
+userdom_stream_connect(NetworkManager_t)
 userdom_dontaudit_use_unpriv_user_fds(NetworkManager_t)
 userdom_dontaudit_use_user_ttys(NetworkManager_t)
+# Read gnome-keyring
+userdom_read_home_certs(NetworkManager_t)
+userdom_read_user_home_content_files(NetworkManager_t)
+userdom_dgram_send(NetworkManager_t)
+
+tunable_policy(`use_nfs_home_dirs',`
+    fs_read_nfs_files(NetworkManager_t)
+')
+
+tunable_policy(`use_samba_home_dirs',`
+    fs_read_cifs_files(NetworkManager_t)
+')
 
 optional_policy(`
 	avahi_domtrans(NetworkManager_t)
 	avahi_kill(NetworkManager_t)
 	avahi_signal(NetworkManager_t)
 	avahi_signull(NetworkManager_t)
+	avahi_dbus_chat(NetworkManager_t)
 ')
 
 optional_policy(`
@@ -196,10 +237,6 @@ optional_policy(`
 ')
 
 optional_policy(`
-	consolekit_read_pid_files(NetworkManager_t)
-')
-
-optional_policy(`
 	consoletype_exec(NetworkManager_t)
 ')
 
@@ -210,16 +247,11 @@ optional_policy(`
 optional_policy(`
 	dbus_system_domain(NetworkManager_t, NetworkManager_exec_t)
 
-	optional_policy(`
-		avahi_dbus_chat(NetworkManager_t)
-	')
+	init_dbus_chat(NetworkManager_t)
 
 	optional_policy(`
 		consolekit_dbus_chat(NetworkManager_t)
-	')
-
-	optional_policy(`
-		policykit_dbus_chat(NetworkManager_t)
+		consolekit_read_pid_files(NetworkManager_t)
 	')
 ')
 
@@ -231,10 +263,11 @@ optional_policy(`
 	dnsmasq_kill(NetworkManager_t)
 	dnsmasq_signal(NetworkManager_t)
 	dnsmasq_signull(NetworkManager_t)
+	dnsmasq_systemctl(NetworkManager_t)
 ')
 
 optional_policy(`
-	gnome_stream_connect_all_gkeyringd(NetworkManager_t)
+    fcoe_dgram_send_fcoemon(NetworkManager_t)
 ')
 
 optional_policy(`
@@ -246,10 +279,26 @@ optional_policy(`
 ')
 
 optional_policy(`
+	gnome_dontaudit_search_config(NetworkManager_t)
+')
+
+optional_policy(`
+    iscsid_domtrans(NetworkManager_t)
+')
+
+optional_policy(`
+    iodined_domtrans(NetworkManager_t)
+')
+
+optional_policy(`
 	ipsec_domtrans_mgmt(NetworkManager_t)
 	ipsec_kill_mgmt(NetworkManager_t)
 	ipsec_signal_mgmt(NetworkManager_t)
 	ipsec_signull_mgmt(NetworkManager_t)
+	ipsec_domtrans(NetworkManager_t)
+	ipsec_kill(NetworkManager_t)
+	ipsec_signal(NetworkManager_t)
+	ipsec_signull(NetworkManager_t)
 ')
 
 optional_policy(`
@@ -257,15 +306,19 @@ optional_policy(`
 ')
 
 optional_policy(`
-	libs_exec_ldconfig(NetworkManager_t)
+	l2tpd_domtrans(NetworkManager_t)
+    l2tpd_sigkill(NetworkManager_t)
+    l2tpd_signal(NetworkManager_t)
+    l2tpd_signull(NetworkManager_t)
 ')
 
 optional_policy(`
-	modutils_domtrans_insmod(NetworkManager_t)
+    lldpad_dgram_send(NetworkManager_t)
 ')
 
 optional_policy(`
 	netutils_exec_ping(NetworkManager_t)
+    netutils_exec(NetworkManager_t)
 ')
 
 optional_policy(`
@@ -274,10 +327,17 @@ optional_policy(`
 	nscd_signull(NetworkManager_t)
 	nscd_kill(NetworkManager_t)
 	nscd_initrc_domtrans(NetworkManager_t)
+	nscd_systemctl(NetworkManager_t)
 ')
 
 optional_policy(`
+	# Dispatcher starting and stoping ntp
 	ntp_initrc_domtrans(NetworkManager_t)
+	ntp_systemctl(NetworkManager_t)
+')
+
+optional_policy(`
+	modutils_domtrans_insmod(NetworkManager_t)
 ')
 
 optional_policy(`
@@ -289,6 +349,7 @@ optional_policy(`
 ')
 
 optional_policy(`
+	policykit_dbus_chat(NetworkManager_t)
 	policykit_domtrans_auth(NetworkManager_t)
 	policykit_read_lib(NetworkManager_t)
 	policykit_read_reload(NetworkManager_t)
@@ -296,7 +357,7 @@ optional_policy(`
 ')
 
 optional_policy(`
-	polipo_initrc_domtrans(NetworkManager_t)
+	polipo_systemctl(NetworkManager_t)
 ')
 
 optional_policy(`
@@ -307,6 +368,7 @@ optional_policy(`
 	ppp_signal(NetworkManager_t)
 	ppp_signull(NetworkManager_t)
 	ppp_read_config(NetworkManager_t)
+	ppp_systemctl(NetworkManager_t)
 ')
 
 optional_policy(`
@@ -320,14 +382,20 @@ optional_policy(`
 ')
 
 optional_policy(`
-	udev_exec(NetworkManager_t)
-	udev_read_db(NetworkManager_t)
-	udev_read_pid_files(NetworkManager_t)
+	systemd_write_inhibit_pipes(NetworkManager_t)
+	systemd_read_logind_sessions_files(NetworkManager_t)
+	systemd_dbus_chat_logind(NetworkManager_t)
+    systemd_hostnamed_manage_config(NetworkManager_t)
+')
+
+optional_policy(`
+    ssh_exec(NetworkManager_t)
 ')
 
 optional_policy(`
-	# unconfined_dgram_send(NetworkManager_t)
-	unconfined_stream_connect(NetworkManager_t)
+	udev_exec(NetworkManager_t)
+	udev_read_db(NetworkManager_t)
+	udev_read_pid_files(NetworkManager_t)
 ')
 
 optional_policy(`
@@ -357,6 +425,4 @@ rw_sock_files_pattern(wpa_cli_t, Network
 init_dontaudit_use_fds(wpa_cli_t)
 init_use_script_ptys(wpa_cli_t)
 
-miscfiles_read_localization(wpa_cli_t)
-
 term_dontaudit_use_console(wpa_cli_t)
Index: serefpolicy-contrib-20140730/ninfod.fc
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/ninfod.fc
@@ -0,0 +1,6 @@
+/usr/lib/systemd/system/ninfod.*		--	gen_context(system_u:object_r:ninfod_unit_file_t,s0)
+
+/usr/sbin/ninfod		--	gen_context(system_u:object_r:ninfod_exec_t,s0)
+
+/var/run/ninfod.*		--	gen_context(system_u:object_r:ninfod_run_t,s0)
+
Index: serefpolicy-contrib-20140730/ninfod.if
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/ninfod.if
@@ -0,0 +1,79 @@
+
+## <summary>Respond to IPv6 Node Information Queries</summary>
+
+########################################
+## <summary>
+##	Execute ninfod in the ninfod domin.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`ninfod_domtrans',`
+	gen_require(`
+		type ninfod_t, ninfod_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, ninfod_exec_t, ninfod_t)
+')
+########################################
+## <summary>
+##	Execute ninfod server in the ninfod domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`ninfod_systemctl',`
+	gen_require(`
+		type ninfod_t;
+		type ninfod_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+    systemd_read_fifo_file_passwd_run($1)
+	allow $1 ninfod_unit_file_t:file read_file_perms;
+	allow $1 ninfod_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, ninfod_t)
+')
+
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an ninfod environment
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+## <rolecap/>
+#
+interface(`ninfod_admin',`
+	gen_require(`
+		type ninfod_t;
+	    type ninfod_unit_file_t;
+	')
+
+	allow $1 ninfod_t:process { signal_perms };
+	ps_process_pattern($1, ninfod_t)
+
+    tunable_policy(`deny_ptrace',`',`
+        allow $1 ninfod_t:process ptrace;
+    ')
+
+	ninfod_systemctl($1)
+	admin_pattern($1, ninfod_unit_file_t)
+	allow $1 ninfod_unit_file_t:service all_service_perms;
+	optional_policy(`
+		systemd_passwd_agent_exec($1)
+		systemd_read_fifo_file_passwd_run($1)
+	')
+')
Index: serefpolicy-contrib-20140730/ninfod.te
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/ninfod.te
@@ -0,0 +1,35 @@
+policy_module(ninfod, 1.0.0)
+
+########################################
+#
+# Declarations
+#
+
+type ninfod_t;
+type ninfod_exec_t;
+init_daemon_domain(ninfod_t, ninfod_exec_t)
+
+type ninfod_run_t;
+files_pid_file(ninfod_run_t)
+
+type ninfod_unit_file_t;
+systemd_unit_file(ninfod_unit_file_t)
+
+########################################
+#
+# ninfod local policy
+#
+allow ninfod_t self:capability { net_raw setuid };
+allow ninfod_t self:process setcap;
+allow ninfod_t self:fifo_file rw_fifo_file_perms;
+allow ninfod_t self:rawip_socket { create setopt };
+allow ninfod_t self:unix_stream_socket create_stream_socket_perms;
+
+manage_files_pattern(ninfod_t, ninfod_run_t, ninfod_run_t)
+files_pid_filetrans(ninfod_t,ninfod_run_t, { file })
+
+auth_use_nsswitch(ninfod_t)
+
+logging_send_syslog_msg(ninfod_t)
+
+sysnet_dns_name_resolve(ninfod_t)
Index: serefpolicy-contrib-20140730/nis.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/nis.fc
+++ serefpolicy-contrib-20140730/nis.fc
@@ -2,21 +2,26 @@
 /etc/rc\.d/init\.d/yppasswd	--	gen_context(system_u:object_r:nis_initrc_exec_t,s0)
 /etc/rc\.d/init\.d/ypserv	--	gen_context(system_u:object_r:nis_initrc_exec_t,s0)
 /etc/rc\.d/init\.d/ypxfrd	--	gen_context(system_u:object_r:nis_initrc_exec_t,s0)
-
 /etc/ypserv\.conf	--	gen_context(system_u:object_r:ypserv_conf_t,s0)
 
-/sbin/ypbind	--	gen_context(system_u:object_r:ypbind_exec_t,s0)
+/sbin/ypbind		--	gen_context(system_u:object_r:ypbind_exec_t,s0)
 
 /usr/lib/yp/ypxfr	--	gen_context(system_u:object_r:ypxfr_exec_t,s0)
 
-/usr/sbin/rpc\.yppasswdd	--	gen_context(system_u:object_r:yppasswdd_exec_t,s0)
+/usr/sbin/rpc\.yppasswdd --	gen_context(system_u:object_r:yppasswdd_exec_t,s0)
+/usr/sbin/rpc\.yppasswdd\.env -- gen_context(system_u:object_r:yppasswdd_exec_t,s0)
 /usr/sbin/rpc\.ypxfrd	--	gen_context(system_u:object_r:ypxfr_exec_t,s0)
 /usr/sbin/ypbind	--	gen_context(system_u:object_r:ypbind_exec_t,s0)
 /usr/sbin/ypserv	--	gen_context(system_u:object_r:ypserv_exec_t,s0)
 
-/var/yp(/.*)?	gen_context(system_u:object_r:var_yp_t,s0)
+/var/yp(/.*)?			gen_context(system_u:object_r:var_yp_t,s0)
 
 /var/run/ypxfrd.*	--	gen_context(system_u:object_r:ypxfr_var_run_t,s0)
 /var/run/ypbind.*	--	gen_context(system_u:object_r:ypbind_var_run_t,s0)
 /var/run/ypserv.*	--	gen_context(system_u:object_r:ypserv_var_run_t,s0)
 /var/run/yppass.*	--	gen_context(system_u:object_r:yppasswdd_var_run_t,s0)
+
+/usr/lib/systemd/system/ypbind.*	--	gen_context(system_u:object_r:ypbind_unit_file_t,s0)
+/usr/lib/systemd/system/ypserv.*	--	gen_context(system_u:object_r:nis_unit_file_t,s0)
+/usr/lib/systemd/system/yppasswdd.*	--	gen_context(system_u:object_r:nis_unit_file_t,s0)
+/usr/lib/systemd/system/ypxfrd.*	--	gen_context(system_u:object_r:nis_unit_file_t,s0)
